#include "formula.h"

formula::formula (void) {
	parts[0] = parts[1] = parts[2] = false;
}

void formula::draw (BITMAP *target, int xo, int yo, int width, int height) {
	char part0[] = "Cr";
	char part1[] = "(NH ) ";
	char part2[] = "Br";

	char sub0[] = "  ";
	char sub1[] = "   3 5";
	char sub2[] = "  ";

	int chars = 10;
	int left = width / 2 - (chars / 2 * 8);

	unsigned long color;
	unsigned long coloron = 0xffffffff;
	unsigned long coloroff = 0xff808080;
	if (parts[0])
		color = coloron;
	else
		color = coloroff;
	textprintf (target, font, xo + left + 0 * 8, yo + height / 2, color, part0);
	textprintf (target, font, xo + left + 0 * 8, yo + height / 2 + 8, color, sub0);


	if (parts[1])
		color = coloron;
	else
		color = coloroff;
	textprintf (target, font, xo + left + 2 * 8, yo + height / 2, color, part1);
	textprintf (target, font, xo + left + 2 * 8, yo + height / 2 + 8, color, sub1);


	if (parts[2])
		color = coloron;
	else
		color = coloroff;
	textprintf (target, font, xo + left + 8 * 8, yo + height / 2, color, part2);
	textprintf (target, font, xo + left + 8 * 8, yo + height / 2 + 8, color, sub2);
}

void formula::add_part (void) {
	if (!got_all_parts()) {
		int sel = rand() % max_parts;
		while (parts[sel]) {
			sel = (sel + 1) % max_parts;
		}
		parts[sel] = true;
	}
}

bool formula::got_all_parts (void) {
	if (selected_parts() == max_parts)
		return true;
	return false;
}

int formula::selected_parts (void) {
	int cnt = 0;
	for (int i = 0; i < max_parts; i++) {
		if (parts[i])
			cnt++;
	}
	return cnt;
}

void formula::clear (void) {
	for (int i = 0; i < max_parts; i++) {
		parts[i] = false;
	}
}
