#include "hero.h"
#include "ex_main.h"

int hero::instances = 0;
BITMAP *hero::phero = 0;

hero::hero (void) {
	try {
		if (instances == 0) {
			phero = load_pcx ("Martian.pcx", 0);
		}
		instances++;
	}
	catch (ex_main e) {
		ex_main::logline ("  |-> called from hero::hero ()");
		throw;
	}

	x = 0.0;
	y = 0.0;
	z = 0.5;
}

hero::~hero (void) {
	instances--;
	if (instances == 0) {
		destroy_bitmap (phero);
	}
}

void hero::draw (BITMAP *target, tins_game *game, int _x, int _y, int _w, int _h) {
	/*
	float s = 1.0 / (5.0 * z + 1.0);
	int sw = s * phero->w;
	int sh = s * phero->h;
	int h_back = phero->h / 5;
	int h_front = phero->h;

	//note: we need to rescale our depths
	//since our poly has depths 1 .. 6
	//and we want to map our local z values 0 .. 1
	//into 1 .. 5

	int y_base = _y + 0.25 * _h + 0.75 * (_h * s);
	int width_depth = (y_base + _h / 2.0) / (3.0 * _h / 2.0) * _w;

	int px = _x + ((_w - width_depth) / 2.0) + x * (width_depth);
	int py = _y + y_base - sh;

	//hline (target, _x + (_w - width_depth) / 2.0, _y + y_base, _x + (_w - width_depth) / 2.0 + width_depth, 0xffffffff);

	masked_stretch_blit (phero, target, 0, 0, phero->w, phero->h, px, py, sw, sh);
	*/

	float s = game->get_scale (z);
	int sw = s * phero->w;
	int sh = s * phero->h;
	int sx, sy;
	game->logical_to_pixel (x, z, &sx, &sy);
        
	masked_stretch_blit (phero, target, 0, 0, phero->w, phero->h, sx - sw / 2, sy - sh, sw, sh);
}

void hero::tick (unsigned int millis) {
	if (key[KEY_UP]) {
		z += millis / 400.0;
	}
	
	if (key[KEY_DOWN]) {
		z -= millis / 400.0;
	}

	if (z <= 0.0)
		z = 0;
	if (z >= 1.0)
		z = 1.0;
}

void hero::position (float *px, float *py, float *pz) {
	if (px != 0)
		*px = x;
	if (py != 0)
		*py = y;
	if (pz != 0)
		*pz = z;
}

int hero::get_width (void) {
	return phero->w;
}

int hero::get_height (void) {
	return phero->h;
}

