#ifndef __TINS_GAME_H
#define __TINS_GAME_H



class tins_game;

#include <allegro.h>
#include "jello_monster.h"
#include "hero.h"
#include "molecule.h"
#include "formula.h"

class tins_game
{
public:
	tins_game (int _xo, int _yo, int _width, int _height, formula *f);
	~tins_game (void);

	void restart (void);

	void draw (BITMAP *target);
	void tick (unsigned int millis);
	float get_scale (float z);
	void logical_to_pixel (float x, float z, int *px, int *py);
protected:
	formula *form;
	void gen_mountains (int width, int height);
	void create_shot (float z);
	void create_molecule_maybe (float x, float z);
	bool spr_intersect (int px1, int py1, int px2, int py2, int qx1, int qy1, int qx2, int qy2);
	void sort_molecules ();
	void sort_monsters ();
	void draw_button (BITMAP *target, int x, int y, int w, int h);
	int xo, yo, width, height;

	float vx;

	static const int gndw = 128;
	static const int gndh = 64;
	BITMAP *pgrnd;

	BITMAP *pmtn;

	const static int max_monsters = 10;
        jello_monster* monsters [max_monsters];
	int num_monsters;

	hero *phero;

	struct shot 
	{
		float x, z;
	};
	static const int max_shots = 50;
	shot shots[max_shots];
	int num_shots;
	int gun_cooldown;

	static const int max_molecules = 20;
	molecule* molecules[max_molecules];
	int num_molecules;

	bool lose;
	bool win;
};



#endif