#include <allegro.h>
#include <iostream>
#include "tins_game.h"
#include "formula.h"

using namespace std;

bool g_exit = false;

void close_button (void) {
	g_exit = true;
}

void init_mode (void) {
	set_color_depth (24);
	set_window_title ("TINS Game");
	if (set_gfx_mode (GFX_AUTODETECT_WINDOWED, 600, 500, 600, 500) < 0) {
		cerr << "Could not create a window of the appropriate mode\n";
		exit(1);
	}
}

BITMAP *g_bground;

int main (int argc, char *argv[]) {
	try {
		srand ((unsigned)time (NULL) );
		ex_main::open_logfile ();
		ex_main::logline ("program starting");

		allegro_init();
		install_timer();
		init_mode ();
		install_keyboard();
		install_mouse();
		set_window_close_hook (close_button);

		BITMAP *poffscreen[2];
		poffscreen[0] = create_video_bitmap(600, 500);
		poffscreen[1] = create_video_bitmap(600, 500);
		int inactive = 1;

		formula f;
		tins_game game (0, 000, 600, 400, &f);

		clear_keybuf();
		
		while (!g_exit) {
			acquire_bitmap (poffscreen[inactive]);
			game.draw (poffscreen[inactive]);
			if (key[KEY_UP]) {
				textprintf (poffscreen[inactive], font,	0, 0, 0xffffffff, "UP");
			}
			if (key[KEY_DOWN]) {
				textprintf (poffscreen[inactive], font,	60, 0, 0xffffffff, "DOWN");
			}
			f.draw (poffscreen[inactive], 0, 400, 600, 100);

			release_bitmap (poffscreen[inactive]);

			show_video_bitmap (poffscreen[inactive]);
			show_mouse (screen);

			inactive = 1-inactive;

			rest(5);
			if (keyboard_needs_poll()) {
				poll_keyboard();
			}
			if (mouse_needs_poll()) {
				poll_mouse();
			}
			game.tick(5);

		}

		set_leds (-1);

		destroy_bitmap (poffscreen[0]);
		destroy_bitmap (poffscreen[1]);

		ex_main::logline ("program terminating");
		ex_main::close_logfile ();
		return 0;
	}
	catch (ex_main e) {
		e.log ();
	}
	return 1;
}
END_OF_MAIN()